map = {}
require('tools')
require('vector')
require('camera')
require('imageBatch')
require('player')
require('editor.entities')
require('editor.saveTable')


--cam = Camera(vector(love.graphics.getWidth()/2, love.graphics.getHeight()/2),1.5) 


msgWindow = love.graphics.newImage('editor/msgWindow.png')
msgWindow:setFilter('nearest','nearest')
tileset = love.graphics.newImage('editor/pkmnTiles.png')
tileset:setFilter('nearest','nearest')
fonts = {}
fonts[12] = love.graphics.newFont(11)
fonts[30] = love.graphics.newFont(30)
love.graphics.setFont(fonts[30])

--fontImage = love.graphics.newImageFont("editor/font.png", "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz1234567890")


tileSize = 16
tiles = {}
numTiles = 50

function love.load()
	for i = 1, numTiles do
		marginX = (1*i)-1
		for k = 1, numTiles do
			marginY = (1*k)-1
			local quad = love.graphics.newQuad( (tileSize*i)-tileSize+marginX, (tileSize*k)-tileSize+marginY, tileSize, tileSize, tileset:getWidth(), tileset:getHeight() )
			if not(tiles[i]) then tiles[i] = {} end
			tiles[i][k] = {quad=quad}
		end
	end
	
	if love.filesystem.exists('map1.pkm') then
		local tempFile ,bytes= love.filesystem.read('map1.pkm')
		
		map = table.load(tempFile)
		if not(map.script) then map.script = {} end
	end
	player.X,player.Y = map.script.playerStart.X,map.script.playerStart.Y
	player.drawX,player.drawY = getPixel(map.script.playerStart.X), getPixel(map.script.playerStart.Y)
--map.objectScripts[19][19] = {script = signs:new('Hiyaasdhadhjasd!')}

end

function love.update()
	local X = love.mouse.getX()
	local Y = love.mouse.getY()
	local tileX = getTile(X)
	local tileY = getTile(Y)
	--cam = Camera(vector(player.drawX, player.drawY),1.5) 
	
	
end

function love.mousepressed(x,y,key)
end

function love.keypressed(key,unicode)

	

	
	player.move(key)
	if key == 'f1' then
		--print('asdasd')
	end
	

end

function love.draw()
	--cam:draw(love.drawP)
	love.drawP()
end
function love.drawP()
	local X = love.mouse.getX()
	local Y = love.mouse.getY()
	local tileX = (math.ceil(X/tileSize))
	local tileY = (math.ceil(Y/tileSize))


	--Draw Map
	for o,p in pairs(map) do
		if not(o  == 'script') and not(o=='objectScripts') and not(o == 5 )then
		print(o)
			if o == 2 then
				if map[5] then
					for q,r in pairs(map[5]) do
						for t,y in pairs(r) do
							love.graphics.drawq(tileset, tiles[y.X][y.Y].quad, (tileSize*q)-tileSize,  (tileSize*t)-tileSize)
						end
					end
				end
				--player systems
				player.move()
				player.draw()
			end
			

			for i,v in pairs(p) do
				for k,d in pairs(v) do
					love.graphics.drawq(tileset, tiles[d.X][d.Y].quad, (tileSize*i)-tileSize,  (tileSize*k)-tileSize)
				end
			end
			if o == 2 then
				entities:draw()
			end
			
		end
	end
	
	

end


















